Index: main/waeup.sirp/trunk/src/waeup/sirp/university/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/interfaces.py	(revision 6557)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/interfaces.py	(revision 6561)
@@ -4,5 +4,5 @@
 from zope.interface import Attribute
 from waeup.sirp.interfaces import (IWAeUPObject, IWAeUPContainer)
-                                   
+
 from waeup.sirp.university.vocabularies import (
     course_levels,
@@ -37,10 +37,10 @@
         required = True,
         )
-        
+
     def longtitle():
         """
         Returns the long title of a faculty.
-        """        
-        
+        """
+
 class IFacultyAdd(IFaculty):
     """Representation of a university faculty.
@@ -53,7 +53,7 @@
         readonly = False,
         )
-                 
-IFacultyAdd['code'].order =  IFaculty['code'].order            
-    
+
+IFacultyAdd['code'].order =  IFaculty['code'].order
+
 class IFacultyContainer(IWAeUPContainer):
     """A container for faculties.
@@ -89,10 +89,10 @@
     courses = Attribute("A container for courses.")
     certificates = Attribute("A container for certificates.")
-    
+
     def longtitle():
         """
         Returns the long title of a department.
         """
-        
+
 class IDepartmentAdd(IDepartment):
     """Representation of a university department.
@@ -105,6 +105,6 @@
         readonly = False,
         )
-                 
-IDepartmentAdd['code'].order =  IDepartment['code'].order         
+
+IDepartmentAdd['code'].order =  IDepartment['code'].order
 
 class ICourseContainer(IWAeUPContainer):
@@ -138,5 +138,5 @@
         required = False,
         )
-    
+
     passmark = schema.Int(
         title = u'Passmark',
@@ -151,9 +151,9 @@
         required = True,
         )
-        
+
     def longtitle():
         """
         Returns the long title of a course.
-        """        
+        """
 
 class ICourseAdd(ICourse):
@@ -167,6 +167,6 @@
         readonly = False,
         )
-        
-ICourseAdd['code'].order =  ICourse['code'].order         
+
+ICourseAdd['code'].order =  ICourse['code'].order
 
 class ICertificate(IWAeUPObject):
@@ -195,18 +195,16 @@
     start_level = schema.Choice(
         title = u'Start Level',
-        #source = LevelSource(),
         vocabulary = course_levels,
         default = 100,
         required = True,
         )
-    
+
     end_level = schema.Choice(
         title = u'End Level',
-        #source = LevelSource(),
         vocabulary = course_levels,
         default = 500,
         required = True,
         )
-    
+
     application_category = schema.Choice(
         title = u'Application Category',
@@ -214,10 +212,10 @@
         default = u'basic',
         required = True,
-        )   
+        )
 
     def longtitle():
         """
         Returns the long title of a certificate.
-        """        
+        """
 
 class ICertificateAdd(ICertificate):
@@ -231,7 +229,7 @@
         readonly = False,
         )
-        
-ICertificateAdd['code'].order =  ICertificate['code'].order         
-    
+
+ICertificateAdd['code'].order =  ICertificate['code'].order
+
 class ICertificateContainer(IWAeUPContainer):
     """A container for certificates.
@@ -244,6 +242,6 @@
 
 class ICertificateCourse(IWAeUPObject):
-    """A certificatecourse is referring a course and 
-       provides some own attributes.
+    """A certificatecourse is referring a course and provides some own
+       attributes.
     """
     course = schema.Choice(
@@ -252,9 +250,8 @@
         readonly = True,
         )
-    
+
     level = schema.Choice(
         title = u'Level',
         required = True,
-        #source = LevelSource(),
         vocabulary = course_levels,
         readonly = False,
@@ -272,13 +269,13 @@
         This is needed for cataloging.
         """
-        
+
     def longtitle():
         """
         Returns the long title of a certificatecourse.
-        """          
-        
-        
+        """
+
+
 class ICertificateCourseAdd(ICertificateCourse):
-    """A certificatecourse is referring a course and 
+    """A certificatecourse is referring a course and
        provides some own attributes.
     """
@@ -288,4 +285,4 @@
         readonly = False,
         )
-                  
-ICertificateCourseAdd['course'].order =  ICertificateCourse['course'].order                  
+
+ICertificateCourseAdd['course'].order =  ICertificateCourse['course'].order