Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_applicants.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_applicants.rst	(revision 6595)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_applicants.rst	(revision 6596)
@@ -18,5 +18,13 @@
    :maxdepth: 1
 
+   applicants/api_interfaces
    applicants/api_root
    applicants/api_container
-   applicants/api_interfaces
+   applicants/api_applicants
+   applicants/api_authentication
+   applicants/api_batching
+   applicants/api_browser
+   applicants/api_permissions
+   applicants/api_vocabularies
+   applicants/api_workflow
+
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_applicants.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_applicants.rst	(revision 6596)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_applicants.rst	(revision 6596)
@@ -0,0 +1,6 @@
+`applicants.applicants` - Applicants Components
+***********************************************
+
+.. automodule:: waeup.sirp.applicants.applicants
+   :members:
+   :undoc-members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_authentication.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_authentication.rst	(revision 6596)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_authentication.rst	(revision 6596)
@@ -0,0 +1,6 @@
+`applicants.authentication` - Applicants Authentication Components
+******************************************************************
+
+.. automodule:: waeup.sirp.applicants.authentication
+   :members:
+   :undoc-members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_batching.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_batching.rst	(revision 6596)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_batching.rst	(revision 6596)
@@ -0,0 +1,6 @@
+`applicants.batching` - Batch Importer for Applicants
+*****************************************************
+
+.. automodule:: waeup.sirp.applicants.batching
+   :members:
+   :undoc-members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_browser.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_browser.rst	(revision 6596)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_browser.rst	(revision 6596)
@@ -0,0 +1,6 @@
+`applicants.browser` - Applicants UI Components
+***********************************************
+
+.. automodule:: waeup.sirp.applicants.browser
+   :members:
+   :undoc-members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_permissions.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_permissions.rst	(revision 6596)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_permissions.rst	(revision 6596)
@@ -0,0 +1,6 @@
+`applicants.permissions` - Applicants Permission Components
+***********************************************************
+
+.. automodule:: waeup.sirp.applicants.permissions
+   :members:
+   :undoc-members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_vocabularies.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_vocabularies.rst	(revision 6596)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_vocabularies.rst	(revision 6596)
@@ -0,0 +1,6 @@
+`applicants.vocabularies` - Vocabularies and Sources
+****************************************************
+
+.. automodule:: waeup.sirp.applicants.vocabularies
+   :members:
+   :undoc-members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_workflow.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_workflow.rst	(revision 6596)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_workflow.rst	(revision 6596)
@@ -0,0 +1,6 @@
+`applicants.workflow` - Applicants Workflow Components
+******************************************************
+
+.. automodule:: waeup.sirp.applicants.workflow
+   :members:
+   :undoc-members: