Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/browser.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/browser.txt	(revision 6612)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/browser.txt	(revision 6613)
@@ -470,4 +470,34 @@
   ...
 
+We can grant local roles:
+
+  >>> browser.open('http://localhost/myuniversity/faculties/TF/TD/manage')
+  >>> browser.getControl(name="user").value = ['bob']
+  >>> browser.getControl(name="local_role").value = ['waeup.local.DepartmentOfficer']
+  >>> browser.getControl("Add local role").click()
+  >>> print browser.contents
+  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"...
+  ...<td>bob</td>
+  ...
+
+The local role can be removed again:
+
+  >>> browser.open('http://localhost/myuniversity/faculties/TF/TD/manage')
+  >>> ctrl = browser.getControl(name='role_id')
+  >>> browser.getControl("Remove selected local roles").click()
+  >>> print browser.contents
+  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"...
+  ...No local role selected...
+  ...
+
+  >>> browser.open('http://localhost/myuniversity/faculties/TF/TD/manage')
+  >>> ctrl = browser.getControl(name='role_id')
+  >>> ctrl.getControl(value='bob|waeup.local.DepartmentOfficer').selected = True
+  >>> browser.getControl("Remove selected local roles").click()
+  >>> print browser.contents
+  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"...
+  ...Successfully removed:...
+  ...
+
 Deleting departments
 --------------------
@@ -519,5 +549,6 @@
 
   >>> dept_url = 'http://localhost/myuniversity/faculties/TF/TD'
-  >>> browser.open(dept_url + '/addcourse')
+  >>> browser.open(dept_url + '/manage')
+  >>> browser.getControl('Add course').click()
   >>> print browser.contents
   <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"...
@@ -651,4 +682,10 @@
   True
 
+  >>> browser.getControl('Cancel', index=0).click()
+  >>> browser.getLink('Manage department').click()
+  >>> browser.getControl('Remove selected courses').click()
+  >>> 'No course selected' in browser.contents
+  True
+
   >>> browser.getControl(name='val_id').getControl(value='COURSE1').selected = True
   >>> browser.getControl('Remove selected courses').click()
@@ -681,5 +718,6 @@
 
   >>> dept_url = 'http://localhost/myuniversity/faculties/TF/TD'
-  >>> browser.open(dept_url + '/addcertificate')
+  >>> browser.open(dept_url + '/manage')
+  >>> browser.getControl('Add certificate').click()
   >>> print browser.contents
   <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"...
@@ -794,4 +832,8 @@
   >>> browser.open('http://localhost/myuniversity/faculties/TF/TD/@@manage#tab-3')
   >>> 'My renamed cert' in browser.contents
+  True
+
+  >>> browser.getControl('Remove selected certificates').click()
+  >>> 'No certificate selected' in browser.contents
   True
 
@@ -859,5 +901,6 @@
 
   >>> cert_url = dept_url + '/certificates/CERT1'
-  >>> browser.open(cert_url + '/addcertificatecourse')
+  >>> browser.open(cert_url + '/manage')
+  >>> browser.getControl('Add course referrer').click()
   >>> print browser.contents
   <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"...
@@ -887,4 +930,16 @@
   'http://localhost/my...sity/faculties/TF/TD/certificates/CERT1/COURSE1_100'
 
+We can't add the same certificatecourse twice:
+
+  >>> cert_url = dept_url + '/certificates/CERT1'
+  >>> browser.open(cert_url + '/manage')
+  >>> browser.getControl('Add course referrer').click()
+  >>> ctrl = browser.getControl(name='form.course')
+  >>> ctrl.getControl('COURSE1').selected = True
+  >>> browser.getControl(name='form.level').value = ['100']
+  >>> browser.getControl('Add course referrer').click()
+  >>> 'The chosen course referrer is already' in browser.contents
+  True
+
 When we started to add a new certificatecourse, we can also cancel the
 process before submitting. This will bring us back to the certificate
@@ -906,10 +961,17 @@
   >>> browser.getLink('Edit course referrer').click()
 
+If we just click 'Save and return' nothing will change:
+
+  >>> browser.getControl("Save and return").click()
+  >>> browser.getLink('COURSE1_100').click()
+  >>> browser.url
+  'http://localhost/myun.../TF/TD/certificates/CERT1/COURSE1_100'
+
 Let's set a new level (it was 100 before) and save the form. This will
 bring us to the certificate index page afterwards:
 
+  >>> browser.open(cert_url + '/COURSE1_100/manage')
   >>> browser.getControl(name='form.level').value = ['200']      
-  >>> ctrl = browser.getControl("Save and return")
-  >>> ctrl.click()
+  >>> browser.getControl("Save and return").click()
 
 As we changed the level, also the URL will change:
@@ -944,5 +1006,7 @@
   >>> 'COURSE1_200</a>' in browser.contents
   True
-
+  >>> browser.getControl('Remove selected course referrers').click()
+  >>> 'No course referrer selected' in browser.contents
+  True
   >>> browser.getControl(name='val_id').getControl(value='COURSE1_200').selected = True
   >>> browser.getControl('Remove selected course referrers').click()